<script setup lang="ts">
import { useAuthStore } from '@/stores/auth';
import { useStockStore } from '@/stores/stock'
import type { Stock } from '@/types/Stock';

import { computed, onMounted, ref } from 'vue'

const authStore = useAuthStore()
const stockStore = useStockStore()
const headersEmployee = [
  {
    key: 'id',
    sortable: false,
    title: 'ProuductId'
  },
  { key: 'name', title: 'ProuductName' },
  { key: 'minimum', title: 'Minimum' },
  { key: 'balance', title: 'Balance' },
  { key: 'unit', title: 'Unit' },
  { key: 'price', title: 'Price' },
  { title: 'Actions', key: 'actions', sortable: false }
]
const headersOwner = [
  {
    key: 'id',
    sortable: false,
    title: 'ProuductId'
  },
  { key: 'name', title: 'ProuductName' },
  { key: 'minimum', title: 'Minimum' },
  { key: 'balance', title: 'Balance' },
  { key: 'unit', title: 'Unit' },
  { key: 'price', title: 'Price' },
  { key: 'branch', title: 'Branch' ,value: (item: any | Stock) => item.branch?.name },
  { title: 'Actions', key: 'actions', sortable: false }
]

const userRole = authStore.getCurrentUser()!.role;
const headersToShow = computed(() => {
  return userRole === 'Owner' ? headersOwner : headersEmployee;
});
const search = ref('')
const loading = ref(false)
function openShowReceipt() {
  stockStore.dialogShowReceipt = !stockStore.dialogShowReceipt
}
function closeDialog() {
  stockStore.closeDialogT()
}
function save() {
  stockStore.save()
  stockStore.closeDialog()
}
onMounted(() => {
  stockStore.getStocks()
})
</script>
<template>
  <v-data-table
    :headers="headersToShow"
    :items="stockStore.stockItems"
    :search="stockStore.search"
    :items-per-page="7"
    
   
  >
    <template v-slot:top>
      <v-dialog v-model="stockStore.dialogE" persistent width="1024">
        <v-card>
          <v-card-title>
            <span class="text-h5">Edit Stock Product</span>
          </v-card-title>
          <v-card-text>
            <v-form ref="refform" v-model="stockStore.formS">
              <v-container>
                <v-row>
                  <v-col cols="12" sm="12" md="4">
                    <v-text-field
                      v-model="stockStore.editedSProduct.name"
                      :readonly="loading"
                      :rules="[(v) => !!v || 'Field is required']"
                      class="mb-2"
                      clearable
                      label="Product Name"
                    ></v-text-field>
                  </v-col>
                  <v-col cols="12" sm="12" md="4">
                    <v-text-field
                      v-model="stockStore.editedSProduct.minimum"
                      :readonly="loading"
                      :rules="[
                        (v) => !!v || 'Field is required',
                        (v) => v > 0 || 'Minimum is Lower'
                      ]"
                      class="mb-2"
                      clearable
                      label="Minimum"
                    ></v-text-field>
                  </v-col>

                  <v-col cols="12" sm="12" md="4">
                    <v-text-field
                      v-model="stockStore.editedSProduct.price"
                      :readonly="loading"
                      :rules="[(v) => !!v || 'Field is required', (v) => v > 0 || 'Price is Lower']"
                      class="mb-2"
                      clearable
                      label="Price"
                    ></v-text-field>
                  </v-col>

                  <v-col cols="12" sm="6">
                    <v-text-field
                      v-model="stockStore.editedSProduct.unit"
                      :readonly="loading"
                      :rules="[
                        (v) => !!v || 'Field is required',
                        (v) => !/\d/.test(v) || 'Field cannot contain numbers'
                      ]"
                      class="mb-2"
                      clearable
                      label="Unit"
                    ></v-text-field>
                  </v-col>
                </v-row>
              </v-container>
            </v-form>
            <small>*indicates required field</small>
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="blue-darken-1" variant="text" @click="closeDialog"> Close </v-btn>
            <v-btn color="blue-darken-1" variant="text" @click="save"> Save </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>

      <v-dialog v-model="stockStore.dialogDelete" max-width="500px">
        <v-card>
          <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="blue-darken-1" variant="text" @click="stockStore.closeDelete"
              >Cancel</v-btn
            >
            <v-btn
              color="blue-darken-1"
              variant="text"
              @click="stockStore.deleteStock(stockStore.editedSProduct)"
              >OK</v-btn
            >
            <v-spacer></v-spacer>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>

    <template v-slot:[`item.actions`]="{ item }">
      <v-icon size="small" class="me-2" @click="stockStore.editSProduct(item)"> mdi-pencil </v-icon>
      <v-icon size="small" @click="stockStore.deleteSProduct(item)"> mdi-delete </v-icon>
    </template>
  </v-data-table> 


<!-- Owner TABLE -->

 </template>
<style>
  tbody tr:nth-of-type(even) {
  background-color: #dddcde;
}

tbody tr:nth-of-type(odd) {
  background-color: #f5f4f7;
}

thead {
  background-color: #403c3c;
  color: rgb(0, 0, 0);
  font-weight: bold;
  color: white;
}

.theme--light.v-data-table thead tr th {
  color: white;
}
</style>
